Page MenuHomeDevCentral

No OneTemporary

diff --git a/README.md b/README.md
index f96ce49..8a7e173 100644
--- a/README.md
+++ b/README.md
@@ -1,56 +1,80 @@
Arcanist as a Docker container
==============================
We provide a `nasqueron/arcanist` image to run **Arcanist** as a Docker container.
Our goal is to be able to use `arc` when we tweak a Docker image on a Docker engine server, where PHP isn't installed. To have an Arcanist image allows us not to install PHP everywhere.
Installation
------------
You only have to pull our image, then invoke a shell or Arc directly:
```
docker pull nasqueron/arcanist
docker run -it --rm nasqueron/arcanist bash
docker run -it --rm nasqueron/arcanist arc anoid
```
Configuration and workspace volumes
-----------------------------------
We provide two volumes, one to store the configuration (.arcrc, .gitconfig), one to store the repository you want to work with.
You probably want to pass the current directory as workspace directory. Use `pwd` (Docker won' t like `.`, and the Docker client could be on another machine than the server by the way).
To store the configuration, create a `~/.arc` folder with:
- `~/.arc/arcrc`: a copy of your .arcrc file
- `~/.arc/gitconfig` : a copy of your .gitconfig file
I want an arc command
---------------------
It could be convenient to create a wrapper script in `/usr/local/bin/arc` to be able to directly write `arc diff`:
```
cat > /usr/local/bin/arc
#!/bin/sh
if [ "$1" = "shell" ]; then
shift
COMMAND=bash
else
mkdir -p ~/.arc
COMMAND=arc
fi
docker run -it --rm -v ~/.arc:/opt/config -v `pwd`:/opt/workspace nasqueron/arcanist $COMMAND $*
```
You can now use `arc shell` to get an interactive shell with your local directory content sent to the container, and `arc <whatever>` in other cases.
> **Note:**
> If you use `arc call-conduit` you can't use -it, as you need to pass stdin to the command.
+
+I want a comprehensive arc command
+-----------------------------------
+
+We provide in `contrib/` folder a choice amongst two wrappers to offer
+a more comprehensive `arc` command:
+
+- `contrib/arc` is the recommended choice: if launched as root,
+ it will use the image as is, but if launched as an user, it will bootstrap
+ by building once a `nasqueron/arcanist:<your uid>-<your gid>` small image
+ to be able to run the container as any arbitrary unprivileged user
+
+- `contrib/arc-runs-as-root` is the legacy version if you prefer to skip
+ the build mechanism and run your container as privileged user
+
+The need for a specific image for user is mainly if you want to use ssh,
+as the OpenSSH client requires the running user to exist, and so requires
+a little more than just add `--user $UID` to the docker run command.
+
+Both wrappers solve the conduit issue by redirecting the output to logging,
+exiting the container when done, waiting a little time then reading the log.
+
+They've been battle-tested and used happily to maintain Git repositories
+for some dozens of Docker images and tools used on a PaaS built on Docker.
diff --git a/contrib/arc b/contrib/arc
index 2eb931e..20fdc0c 100755
--- a/contrib/arc
+++ b/contrib/arc
@@ -1,65 +1,93 @@
-#!/bin/sh
+#!/usr/bin/env bash
# -------------------------------------------------------------
# Phabricator — Arcanist Docker container wrapper
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Author: Sébastien Santoro aka Dereckson
# Project: Nasqueron
# Created: 2016-01-01
# Description: Wrapper to run Arcanist as a Docker container
# License: Trivial work, not eligible to copyright
+# If copyright eligible, BSD-2-Clause
# Image: nasqueron/arcanist
# -------------------------------------------------------------
# -------------------------------------------------------------
# Parse arguments
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if [ -t 0 ]; then
# If a stdin entry is available
# launch the container in the
# interactive mode
FLAGS=-it
fi
# Logs are default disabled
PRINT_LOG=0
-
if [ "$1" = "shell" ]; then
# Launch commands
# in the container bash shell
shift
COMMAND=bash
else
# Launch arc
mkdir -p ~/.arc
COMMAND=arc
if [ "$1" = "call-conduit" ]; then
# Enable log printing
PRINT_LOG=1
# Set a random name for the container
- INSTANCE="arc-"`openssl rand -hex 21`
+ INSTANCE="arc-"$(openssl rand -hex 21)
FLAGS="-i -a=stdin --name=$INSTANCE"
fi
fi
-if [ -d ~/.arc/ssh ]; then
- VOLUME_SSH="-v $HOME/.arc/ssh:/root/.ssh"
+# -------------------------------------------------------------
+# Build image
+# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+build_user_image () {
+ BUILD_DIR=$(mktemp -d -t arc-build-XXXXXXXXXX)
+ pushd "$BUILD_DIR" > /dev/null || exit 1
+ >&2 echo "🔨 Building user-specific image $IMAGE for $USER"
+ echo "FROM nasqueron/arcanist" > Dockerfile
+ echo "RUN groupadd -r $USER -g $GID && mkdir /home/$USER && useradd -u $UID -r -g $USER -d /home/$USER -s /bin/bash $USER && cp /root/.bashrc /home/$USER/ && chown -R $USER:$USER /home/$USER && ln -s /opt/config/gitconfig /home/$USER/.gitconfig && ln -s /opt/config/arcrc /home/$USER/.arcrc" >> Dockerfile
+ docker build -t "$IMAGE" .
+ popd > /dev/null
+ rm -rf "$BUILD_DIR"
+}
+
+test -v $UID && UID=$(id -u)
+test -v $GID && GID=$(id -g)
+
+if [ $UID -eq 0 ]; then
+ IMAGE=nasqueron/arcanist
+ CONTAINER_USER_HOME=/root
else
- VOLUME_SSH=""
+ IMAGE=nasqueron/arcanist:$UID-$GID
+ test ! -z $(docker images -q "$IMAGE") || build_user_image
+ CONTAINER_USER_HOME="/home/$USER"
fi
# -------------------------------------------------------------
# Run container
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
+
+if [ -d ~/.arc/ssh ]; then
+ VOLUME_SSH="-v $HOME/.arc/ssh:$CONTAINER_USER_HOME/.ssh"
+else
+ VOLUME_SSH=""
+fi
+
if [ $PRINT_LOG -eq 0 ]; then
- docker run $FLAGS --rm -v ~/.arc:/opt/config -v $PWD:/opt/workspace $VOLUME_SSH nasqueron/arcanist $COMMAND $*
+ docker run $FLAGS --rm --user $UID:$GID -v ~/.arc:/opt/config -v "$PWD:/opt/workspace" $VOLUME_SSH $IMAGE $COMMAND "$@"
else
- docker run $FLAGS -v ~/.arc:/opt/config -v $PWD:/opt/workspace $VOLUME_SSH nasqueron/arcanist $COMMAND $* > /dev/null
+ docker run $FLAGS --user $UID:$GID -v ~/.arc:/opt/config -v "$PWD:/opt/workspace" $VOLUME_SSH $IMAGE $COMMAND "$@" > /dev/null
sleep 3
- docker logs $INSTANCE
- docker rm $INSTANCE >/dev/null
+ docker logs "$INSTANCE"
+ docker rm "$INSTANCE" >/dev/null
fi
diff --git a/contrib/arc b/contrib/arc-to-run-as-root
similarity index 100%
copy from contrib/arc
copy to contrib/arc-to-run-as-root

File Metadata

Mime Type
text/x-diff
Expires
Sun, Nov 24, 22:23 (11 h, 34 m)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
2259035
Default Alt Text
(6 KB)

Event Timeline